<?php

function stbl_get_adsense($attributes)
{
	ob_start();

	if ( is_singular() ) {

		$post_id = get_the_ID();

		$hide_ad_value = get_post_meta( $post_id,'no_ad', true );

		if ( $hide_ad_value === 'is-off' ) return '';
	}

	if ( is_404() ) return '';

	$adsense_code = !empty( $attributes['code'] ) ? $attributes['code'] : '';
    $available_pc = isset( $attributes['displayPC'] ) ? $attributes['displayPC'] : true;
    $available_sp = isset( $attributes['displaySP'] ) ? $attributes['displaySP'] : true;

	if ( stbl_is_mobile() ) {
		if ( ! $available_sp ) return;
	} else {
		if ( ! $available_pc ) return;
	}

	$src = false;
    $ins = false;

	if ( ! empty( get_option( 'rtvl_adsense_available_lazyload' ) ) ) {
      
		$adsense_code = str_replace( array("\r\n", "\r", "\n"), "", $adsense_code );
  
		$pattern = '/<script.*?src\s*=\s*[\"|\'](.*?)[\"|\'].*?>/i';
		if ( preg_match( $pattern, $adsense_code, $matches) ) {
			$src = $matches[1];
		}
  
		$pattern2 = '/<ins.*?<\/ins>/';
		if ( preg_match( $pattern2, $adsense_code, $matches) ) {
			$ins = $matches[0];
		}
	}
?>
	<?php if ( $src && $ins ) : ?>
		<div class="adsense-wrap" data-adsrc="<?php echo $src; ?>">
			<?php echo $ins; ?>
		</div>
	<?php else : ?>
		<div class="adsense-wrap">
			<?php echo $adsense_code; ?>
		</div>
    <?php endif; ?>
<?php
	$content = ob_get_clean();

	return $content;
}


function stbl_register_block_adsense() {
	register_block_type( 'streetist-blocks/adsense', array(
		'editor_script' => 'editor-script-streetist-blocks',
		'editor_style' => 'editor-style-streetist-blocks',
		'script' => 'script-streetist-blocks',
		'style' => 'style-streetist-blocks',
		'attributes' 	=> array(
			'code'   => array(
				'type' => 'string',
			),
			'displayPC'   => array(
				'type' => 'boolean',
				'default' => true,
			),
			'displaySP'   => array(
				'type' => 'boolean',
				'default' => true,
			),
		),
		'render_callback' => 'stbl_get_adsense',
	));
}
add_action( 'init', 'stbl_register_block_adsense' );